#include "stdafx.h"
#include "INpMac.h"


#pragma warning(disable:4996)

void memdump(void * data,size_t size);



////////////////////////////////////////////////////////////////////////////
// @	CXbhB
// 	gp
// ߂l	0
////////////////////////////////////////////////////////////////////////////
int _tmain(int argc, _TCHAR* argv[])
{
	int					iID = 0;
	int					iSize;
	int					iGroupNo;
	int					iOffset;
	int					iBuffSize;

	char				szKey[256]={0};
	BYTE				*bData;


	printf("////////////////////////////////////////\n"
		   "//  INpMac SAMPLE\n"
		   "////////////////////////////////////////\n");

	while (1)
	{
		printf("\nSet menu (10:Menu list) >> ");

		gets(szKey);
		if ( szKey[0] == 0x00 ){
			continue;
		}

		iID = atoi(szKey);

		switch(iID){
			case 10:	// APIeXgpj[Xg
				printf( "** [ Menu ] ******************************\n" );
				printf( "** ID NAME             | ID NAME             \n" );
				printf( "**  1 [Q-AREA] Get_Size  |  2 [Q-AREA] Get_Data  \n" );
				printf( "**  3 [I-AREA] Get_Size  |  4 [I-AREA] Set_Data  \n" );
				printf( "** 99 End  \n" );
				break;

			case 1:		// [Q-AREA] Get_Size
				printf("GroupNo     --> ");
				gets(szKey);				
				iGroupNo = (int)atoi(szKey);

				// [QGÃTCY擾]
				iSize = INpMac_Get_Qarea_Size(iGroupNo);

				if( iSize < 0  ){
					printf("\nQ-AREA Get_Size error 0x%08X\n", iSize);
				}
				else{
					printf("\nQ-AREA Get_Size = %d(0x%08X)\n", iSize, iSize);
				}
				break; 

			case 2:		// [Q-AREA] Get_Data
				printf("GroupNo     --> ");
				gets(szKey);				
				iGroupNo = (int)atoi(szKey);

				printf("Offset     --> ");
				gets(szKey);				
				iOffset = (int)atoi(szKey);

				printf("Buff_Size  --> ");
				gets(szKey);
				iBuffSize = (int)atoi(szKey);
				bData = (BYTE *)malloc(iBuffSize);
				
				// [QGÃf[^̓Ǎ]
				iSize = INpMac_Get_Qarea(iGroupNo,iOffset,bData,iBuffSize);

				if( iSize < 0  ){
					printf("\nQ-AREA Get_Data error 0x%08X\n", iSize);
				}
				else{
					printf("\nQ-AREA Get_Data = %d(0x%08X)\n", iSize, iSize);
					memdump(bData, iSize);
				}

				free(bData);
				break;

			case 3:		// [I-AREA] Get_Size
				printf("GroupNo     --> ");
				gets(szKey);				
				iGroupNo = (int)atoi(szKey);

				// [IGÃTCY擾]
				iSize = INpMac_Get_Iarea_Size(iGroupNo);

				if( iSize < 0  ){
					printf("\nI-AREA Get_Size error 0x%08X\n", iSize);
				}
				else{
					printf("\nI-AREA Get_Size = %d(0x%08X)\n", iSize, iSize);
				}

				break; 

			case 4:		// [I-AREA] Set_Data
				printf("GroupNo     --> ");
				gets(szKey);				
				iGroupNo = (int)atoi(szKey);

				printf("Offset     --> ");
				gets(szKey);				
				iOffset = (int)atoi(szKey);
				memset(szKey, 0x00, sizeof(szKey));
				printf("Set Data(MAX:256Byte) --> ");
				gets(szKey);
				iBuffSize = (int)strlen(szKey);
				
				// [IGAփf[^̏]
				iSize = INpMac_Set_Iarea(iGroupNo,iOffset,(BYTE *)szKey,iBuffSize);

				if( iSize < 0  ){
					printf("\nI-AREA Set_Data error 0x%08X\n", iSize);
				}
				else{
					printf("\nI-AREA Set_Data = %d(0x%08X)\n", iSize, iSize);
					memdump(szKey, iSize);
				}

				break;


			case 99:	// End
				break;
		}

		// End
		if(iID == 99)
			break;
	}

	return 0;
}



////////////////////////////////////
// DUMP
void memdump(void * data,size_t size)
{
	UINT		lp1,lp2;
	char		buff[80];
	char		line[80];
	
	for(lp1=0;lp1<(size+15)/16;lp1++){
		line[0]='\0';
		sprintf(buff,"%03X0: ",lp1);
		strcat(line,buff);
		for(lp2=0;lp2<16;lp2++){
			if((lp1*16+lp2)<size){
				sprintf(buff,"%02X ",*((BYTE *)data+lp1*16+lp2));
				strcat(line,buff);
			}
			else
				strcat(line,"   ");
		}
		for(lp2=0;(lp2<16)&&((lp1*16+lp2)<size);lp2++){
			if((*((BYTE *)data+lp1*16+lp2)>=32)&&(*((BYTE *)data+lp1*16+lp2)<=127)){
				sprintf(buff,"%c",*((BYTE *)data+lp1*16+lp2));
				strcat(line,buff);
			}
			else
				strcat(line,".");
		}
		strcat(line,"\x0d\x0a");
		printf(line);
	}
}
